!*****************************************************************************
!                                                                            *
!  DCB.F90                                                                   *
!                                                                            *
!  This program demonstrates the Fastgraph for Windows direct color bitmap   *
!  display functions.                                                        *
!                                                                            *
!*****************************************************************************

integer*4 function WinMain (hInstance, hPrevInstance, lpszCmdParam, nCmdShow)
!MS$ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
use msfwina
use fgwin

interface
integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
integer*4 window, message, wParam, lParam
end function WindowProc
end interface

integer*4 hInstance, hPrevInstance, lpszCmdParam, nCmdShow

character*12      AppName
integer*4         iret
integer*4         window
type (T_MSG)      msg
type (T_WNDCLASS) wndclass

data AppName /'FGdcb'C/

if (hPrevInstance == 0) then
   wndclass%style         = CS_HREDRAW .or. CS_VREDRAW .or. CS_OWNDC
   wndclass%lpfnWndProc   = LOC(WindowProc)
   wndclass%cbClsExtra    = 0
   wndclass%cbWndExtra    = 0
   wndclass%hInstance     = hInstance
   wndclass%hIcon         = LoadIcon(NULL,IDI_APPLICATION)
   wndclass%hCursor       = LoadCursor(NULL,IDC_ARROW)
   wndclass%hbrBackground = NULL
   wndclass%lpszMenuName  = LOC(AppName)
   wndclass%lpszClassName = LOC(AppName)
   iret = RegisterClass(wndclass)
   lpszCmdParam = lpszCmdParam
end if

window = CreateWindow(      &
   AppName,                 &  ! window class name
   'Direct Color Bitmap Demo'C, & ! window caption
   WS_OVERLAPPEDWINDOW,     &  ! window style
   CW_USEDEFAULT,           &  ! initial x position
   CW_USEDEFAULT,           &  ! initial y position
   CW_USEDEFAULT,           &  ! initial x size
   CW_USEDEFAULT,           &  ! initial y size
   NULL,                    &  ! parent window handle
   NULL,                    &  ! window menu handle
   hInstance,               &  ! program instance handle
   NULL)                       ! creation parameters

iret = ShowWindow(window,nCmdShow)
iret = UpdateWindow(window)

do while (GetMessage(msg,NULL,0,0))
   iret = TranslateMessage(msg)
   iret = DispatchMessage(msg)
end do

WinMain = msg%wParam
return
end

!*****************************************************************************
!                                                                            *
!  WindowProc                                                                *
!                                                                            *
!  Window procedure to handle messages sent to the window.                   *
!                                                                            *
!*****************************************************************************

integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
use msfwina
use fgwin
integer*4 window, message, wParam, lParam

include 'dcb.fi'

type (T_PAINTSTRUCT) ps
integer*4 cxClient, cyClient
integer*4 hdc, hpal, hvb
integer*4 iret

save cxClient, cyClient, hdc, hpal, hvb

WindowProc = 0

select case (message)

   case (WM_CREATE)
      hdc = GetDC(window)
      call fg_setdc(hdc)
      hpal = fg_defpal()
      call fg_realize(hpal)

      call fg_vbinit
      call fg_vbdepth(16)
      hvb = fg_vballoc(WIDTH,HEIGHT)
      iret = fg_vbopen(hvb)
      call fg_vbcolors

      call fg_setcolor(fg_maprgb(85,255,85))
      call fg_fillpage
      return

   case (WM_COMMAND)
      select case (wParam)
         case (IDM_DRAWDCB)
            call fg_fillpage()
            call fg_move(WIDTH/2-20,HEIGHT/2+10)
            call fg_drawdcb(bird,40,20)
            call fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1)
            return

         case (IDM_CLIPDCB)
            call fg_fillpage()
            call fg_move(-20,HEIGHT/2+10)
            call fg_clipdcb(bird,40,20)
            call fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1)
            return

         case (IDM_REVDCB)
            call fg_fillpage()
            call fg_move(WIDTH/2-20,HEIGHT/2+10)
            call fg_revdcb(bird,40,20)
            call fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1)
            return

         case (IDM_FLIPDCB)
            call fg_fillpage()
            call fg_move(WIDTH-20,HEIGHT/2+10)
            call fg_flipdcb(bird,40,20)
            call fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1)
            return

         case (IDM_PUTDCB)
            call fg_fillpage()
            call fg_move(WIDTH/2-20,HEIGHT/2+10)
            call fg_putdcb(bird,40,20)
            call fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1)
            return

         case (IDM_QUIT)
            iret = DestroyWindow(window)
            return
      end select

   case (WM_PAINT)
      iret = BeginPaint(window,ps)
      call fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1)
      iret = EndPaint(window,ps)
      return

   case (WM_SETFOCUS)
      call fg_realize(hpal)
      iret = InvalidateRect(window,NULL_RECT,.TRUE.)
      return

   case (WM_SIZE)
      cxClient = LOWORD(lParam)
      cyClient = HIWORD(lParam)
      return

   case (WM_DESTROY)
      call fg_vbclose
      call fg_vbfree(hvb)
      call fg_vbfin
      iret = DeleteObject(hpal)
      iret = ReleaseDC(window,hdc)
      call PostQuitMessage(0)
      return

end select

WindowProc = DefWindowProc(window,message,wParam,lParam)
return
end

!*****************************************************************************

block data

include 'dcb.fi'

! 40x20 high color bitmapped image of a bird
data bird2 / &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0821,#0821,#0000,#0821,#0000,#0821,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0821,#FFFF,#0821,#AD55,#0821,#AD55,#0821,#0821, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0821,#FFFF,#FFFF,#0821,#AD55,#0821,#AD55,#0821,#FFFF, &
   #0821,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0821,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#0821,#FFFF,#FFFF, &
   #0821,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0821,#0821,#0821, &
   #0821,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#0821,#FFFF,#0821, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0821,#0821,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0821,#FFFF,#FFFF,#FFFF, &
   #0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821, &
   #0000,#0000,#0821,#0821,#0821,#0821,#0821,#AD55,#0821,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0821,#0821,#FFFF,#FFFF,#0821, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000, &
   #0000,#0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0821,#FFFF,#FFFF,#0821,#FFFF,#FFFF, &
   #0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000, &
   #0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0821,#FFFF,#0821,#FFFF,#FFFF,#0821,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000, &
   #0821,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0821,#FFFF,#FFFF,#0821,#FFFF,#FFFF,#0821, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0821, &
   #FFFF,#FFFF,#FFFF,#FFFF,#0821,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0821,#FFFF,#0821,#FFFF,#FFFF,#0821,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#0821,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0821,#0821,#FFFF,#FFFF,#0821,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#FFFF, &
   #0821,#FFFF,#0821,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0821,#FFFF,#0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#FFFF, &
   #FFFF,#FFFF,#0821,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0821,#0821,#0821,#0821,#0000,#0000,#0000,#0000,#0000, &
   #0821,#FFFF,#FFFF,#0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821, &
   #FFFF,#0821,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0821,#AD55,#AD55,#AD55,#AD55,#0821,#0821,#0821,#0821,#0000, &
   #0821,#0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#FFFF,#FFFF,#0821, &
   #0821,#0821,#0821,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0821,#AD55,#AD55,#AD55,#AD55,#AD55,#AD55,#AD55,#0821, &
   #FFFF,#FFFF,#0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#0821,#FFFF,#FFFF,#FFFF,#0821,#AD55, &
   #AD55,#AD55,#AD55,#0821,#0821,#0821,#0821,#0821,#0821,#0000, &
   #0000,#0000,#0821,#0821,#0821,#0821,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#0821,#A800,#A800,#0821,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0821,#0821,#0821,#0821, &
   #0821,#0821,#0821,#0821,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#A800,#FFFF,#FFFF,#0821,#0821,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0821,#0821,#FFFF,#FFFF,#FFFF,#FFFF, &
   #FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#FFFF,#0821,#0821,#0821, &
   #0821,#FFFF,#FFFF,#FFFF,#0821,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000,#0000, &
   #0000,#0000,#0000,#0000,#0000,#0000,#0821,#0821,#0821,#0821, &
   #0821,#0821,#0821,#0821,#0821,#0821,#0821,#0000,#0000,#0000, &
   #0000,#0821,#0821,#0821,#0000,#0000,#0000,#0000,#0000,#0000/

end
