/****************************************************************************\
*                                                                            *
*  FADE.CPP                                                                  *
*  FADEU.CPP                                                                 *
*                                                                            *
*  This program shows how perform a palette fade.                            *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "FadeU.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
    WIDTH(320),
    HEIGHT(200)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb);
   fg_vbcolors();

   fg_showpcx("MOUSE.PCX",2);
   fg_getdacs(10,236,original);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}

/****************************************************************************\
*                                                                            *
*  Fade an image back to its original colors.                                *
*                                                                            *
\****************************************************************************/

void __fastcall TForm1::FadeIn1Click(TObject *Sender)
{
   register int i;
   bool fading;

   memset(current,0,236*3);

   do
   {
      fading = False;
      for (i = 0; i < 236*3; i++)
      {
         if (current[i] != original[i])
         {
            current[i]++;
            fading = True;
         }
      }
      fg_setdacs(10,236,current);
      if (fg_colors() > 8)
         fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
   }
   while (fading);

   FadeOut1->Enabled = True;
   FadeIn1->Enabled = False;
}

/****************************************************************************\
*                                                                            *
*  Fade an image to black.                                                   *
*                                                                            *
\****************************************************************************/

void __fastcall TForm1::FadeOut1Click(TObject *Sender)
{
   register int i;
   bool fading;
   memcpy(current,original,236*3);

   do
   {
      fading = False;
      for (i = 0; i < 236*3; i++)
      {
         if (current[i] != 0)
         {
            current[i]--;
            fading = True;
         }
      }
      fg_setdacs(10,236,current);
      if (fg_colors() > 8)
         fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
   }
   while (fading);

   FadeOut1->Enabled = False;
   FadeIn1->Enabled = True;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Quit1Click(TObject *Sender)
{
   Application->Terminate();
}
//---------------------------------------------------------------------------
